#include <systemc.h>
#include "ClockCounter.h"

int sc_main( int argc, char* argv[] )
{
    ClockCounter *clockCounter;

    // signals
    sc_clock                 clk( "clk", 10.0, SC_NS );
    sc_signal<unsigned int>  CntOut;

    // module instance & binding
    clockCounter = new ClockCounter( "ClockCounter" );
    sc_assert( clockCounter );
    clockCounter->clk( clk );
    clockCounter->CntOut( CntOut );

    /////////////////////////////////////////////////////////////////////////
    // vcd dump
    sc_trace_file *trace_f;
    trace_f = sc_create_vcd_trace_file( "systemc" ); // ϥե̾ꤹ
    sc_assert( trace_f );
    trace_f->set_time_unit( 1.0, SC_NS );

    sc_trace( trace_f, clk, "clk" );
    sc_trace( trace_f, CntOut, "CntOut" );

    /////////////////////////////////////////////////////////////////////////
    // initialize
    sc_start( SC_ZERO_TIME );
    cout << sc_time_stamp() << " : " << "CntOut = " << CntOut.read() << endl;

    // simulation
    sc_start( 10.0, SC_NS );
    cout << sc_time_stamp() << " : " << "CntOut = " << CntOut.read() << endl;

    sc_start( 50.0, SC_NS );
    cout << sc_time_stamp() << " : " << "CntOut = " << CntOut.read() << endl;

    sc_start( 135.0, SC_NS );
    cout << sc_time_stamp() << " : " << "CntOut = " << CntOut.read() << endl;

    sc_start( 37.0, SC_NS );
    cout << sc_time_stamp() << " : " << "CntOut = " << CntOut.read() << endl;

    sc_start( 500.0, SC_NS );
    cout << sc_time_stamp() << " : " << "CntOut = " << CntOut.read() << endl;

    /////////////////////////////////////////////////////////////////////////

    delete clockCounter;
    sc_close_vcd_trace_file( trace_f );

    return 0; 
}
